<?php
//@ini_set("display_errors", "1"); error_reporting(E_ALL);
@ini_set("display_errors", "0"); error_reporting(0);

require("/netup/utm5/bin/helpdesk/helpdesk.php");
require_once("../stat/urfa/URFAClient.php");
include ("../stat/urfa/URFAConfig.php");
include ('config.php');

function GetResponceHeader($Request) {
	$Responce = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
	if ($Request['action']=='checkOrder')	$Responce.= "<checkOrderResponse ";
	if ($Request['action']=='paymentAviso') $Responce.= "<paymentAvisoResponse ";
	$Responce.= "performedDatetime=\"".date('c')."\" ";
	$Responce.= "shopId=\"".$Request['shopId']."\" ";
	$Responce.= "orderSumAmount=\"".$Request['orderSumAmount']."\" ";
	$Responce.= "invoiceId=\"".$Request['invoiceId']."\" ";
	return($Responce);	
}

function CheckMD5($Request) {
	global $file_handle, $shopPassword;
	$Responce = GetResponceHeader($Request);
	$str = $Request['action'].';'.$Request['orderSumAmount'].';'.$Request['orderSumCurrencyPaycash'].';'.$Request['orderSumBankPaycash'].';'.$Request['shopId'].';'.$Request['invoiceId'].';'.$Request['customerNumber'].';'.$shopPassword;
//								 action;                orderSumAmount;                orderSumCurrencyPaycash;                orderSumBankPaycash;                shopId;                invoiceId;                customerNumber;       shopPassword
	$MD5str = strtoupper(md5($str));

	fwrite($file_handle, date("d.m.Y H:i:s")." Строка для расчета md5: ".$str."\r\n");
	fwrite($file_handle, date("d.m.Y H:i:s")." Расчетный md5: ".$MD5str."\r\n");
	fwrite($file_handle, date("d.m.Y H:i:s")." Серверный md5: ".$Request['md5']."\r\n");
	if ($Request['md5']!=$MD5str) {
		$Responce.= "code=\"1\" ";
		$Responce.= "message=\"Несовпадение значения параметра md5 с результатом расчета хэш-функции\" ";
		$Responce.= "/>";
		return($Responce);
	} else {
		$Responce = "OK";
		return($Responce);
	}
}

function checkOrder($Request) {
	global $db_connect;
	$Responce = GetResponceHeader($Request);
	if (!isset($Request['customerNumber'])) { 		
		$Responce.= "code=\"100\" ";
		$Responce.= "message=\"Не указан Лицевой счет\" ";
		$Responce.= "/>";
		return($Responce);
	}
	$account = $Request['customerNumber'];
	$query = "SELECT id FROM accounts WHERE id = $account";
	$result = mysql_query($query,$db_connect);
	if (mysql_num_rows($result)==0) {
		$Responce.= "code=\"100\" ";
		$Responce.= "message=\"Указанный Лицевой счет не существует\" ";
		$Responce.= "/> ";
		return($Responce);
	}		
	$Responce.= "code=\"0\" ";
	$Responce.= "/>";
	return($Responce);
}

function paymentAviso($Request) {
	global $db_connect, $file_handle, $payment_method,$UTMCore_Login,$UTMCore_Password,$UTMCoreHost,$UTMCorePort;
	$Responce = GetResponceHeader($Request);
	
	$sign = 'Оплата Яндекс.Деньги, номер покупки '.$Request['invoiceId'];
	$payment_time = time();
	$burn_date = 0;
	$account = $Request['customerNumber'];
	$summa = $Request['orderSumAmount'];
	$payment_ext_number = $Request['invoiceId'];

	$query = "SELECT account_id FROM payment_transactions WHERE method = $payment_method AND payment_ext_number = $payment_ext_number";
	$result = mysql_query($query,$db_connect);
	if (mysql_num_rows($result)>0) { // Платёж уже внесен, возвращаем отсутсиве ошибки, выходим.
		$Responce.= "code=\"0\" ";
		$Responce.= "/>";
		return($Responce);
	}
	// Платеж в биллинге Начало
	try {
		$urfa_admin = new URFAClient_Admin($UTMCore_Login,$UTMCore_Password,$UTMCoreHost,$UTMCorePort);
	} catch (Exception $exception) { 
		fwrite($file_handle, date("d.m.Y H:i:s")." ".$payment_ext_number." Billing core error!!!\r\n");
		$Responce.= "code=\"200\" ";
		$Responce.= "message=\"Billing core error\" ";
		$Responce.= "/> ";
		return($Responce);			
	} 
	$payment_transaction_id = $urfa_admin->rpcf_add_payment_for_account($account,$summa,$payment_time,$burn_date,$payment_method,$sign,$sign,$payment_ext_number,1); //0x3110
	// Платеж в биллинге Конец
	if (isset($payment_transaction_id['payment_transaction_id'])) {
		// Отправляем сообщение пользователю Начало
		$author = 'Системное сообщение';
		$message = 'Поступил платеж на сумму '.$summa.' рублей. '.'Метод платежа Яндекс.Деньги';
		$service_message = 'Яндекс.Деньги';
		SendMessageToUser($account,$author,$message,$service_message);
		// Отправляем сообщение пользователю Конец
		fwrite($file_handle, date("d.m.Y H:i:s")." ".$payment_ext_number." PAYMENT OK\r\n"); 
		$Responce.= "code=\"0\" ";
		$Responce.= "/>";
		return($Responce);
	}
	$Responce.= "code=\"200\" ";
	$Responce.= "message=\"Billing payment error\"";
	$Responce.= "/>";
	return($Responce);
	fwrite($file_handle, date("d.m.Y H:i:s")." ".$payment_ext_number." ADD PAYMENT ERROR !!!\r\n");
}

?>